/*
 * MGL -- MobileGear Graphic Library -
 * Copyright (C) 1998, 1999
 *      Koji Suzuki (suz@at.sakura.ne.jp)
 *      Yukihiko Sano (yukihiko@yk.rim.or.jp)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY KOJI SUZUKI AND YUKIHIKO SANO ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include "mgl2.h"

extern int (*im_readp)();

int main() {
	char buf[256];
	struct textscreen *t;
	int ret;
	int i;

	open_graph();
	set_font(12,0);
	set_color(COLOR_WHITE);
	clear_screen();

	t = create_textscreen(NULL,20,20,600,12*10+8,TS_BORDER|TS_BLINE);
#if 0
	while (1) {
		ret = im_read(buf,256,30,30,200);
		if (ret > 0) {
			buf[ret] = 0;
			set_color(COLOR_BLACK);
			ts_put_string(t,buf,0);
		}
	}
#else
	i = 0;
	set_color(COLOR_BLACK);
	while (1) {
		ret = get_key_im(-1);
		if (!(ret & 0x80)) {
			buf[0] = ret;
			buf[1] = 0;
			ts_put_string(t,buf,0);
			if (ret == 033 || ret == 'c'&0x1f)
				break;
		} else {
			buf[0] = ret;
			ret = get_key_im(-1);
			buf[1] = ret;
			buf[2] = 0;
			ts_put_string(t,buf,0);
		}
refresh();
	}
#endif
}
