/*
 * MGL -- MobileGear Graphic Library -
 * Copyright (C) 1998, 1999
 *      Koji Suzuki (suz@at.sakura.ne.jp)
 *      Yukihiko Sano (yukihiko@yk.rim.or.jp)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY KOJI SUZUKI AND YUKIHIKO SANO ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

// not implemented yet, so the same as default.

void mk_create_raw_keymap() {
	int i,j,n;
	int tmp;
	int jp=0;
	int c;
	int sym1,sym2,sym3;
	int raw[128];
	int found[128];
	int keymap[128][3];

	for (i=0; i< 128; i++) {
		raw[i] = 0;
		found[i] = 0;
		keymap[i][0] = MK_NONE;
		keymap[i][1] = MK_NONE;
		keymap[i][2] = MK_NONE;
	}
	for (i=1; i< 128; i++) {
		sym1 = mgl_keymap[i][0];
		sym2 = mgl_keymap[i][1];
		sym3 = mgl_keymap[i][2];
		c = search_rawcode(sym1,sym2,jp,found);
		if (c) {
			raw[i] = c;
			found[c] = i;
			keymap[c][0] = sym1;
			keymap[c][1] = sym2;
			keymap[c][2] = sym3;
		}
	}
	for (i=1; i< 128; i++) {
		if ((mgl_keymap[i][0] != MK_NONE) && (!raw[i])) {
			if (!found[i]) {
				raw[i] = i;
				found[i] = i;
				keymap[i][0] = mgl_keymap[i][0];
				keymap[i][1] = mgl_keymap[i][1];
				keymap[i][2] = mgl_keymap[i][2];
			}
		}
	}
	for (i=1; i< 128; i++) {
		if ((mgl_keymap[i][0] != MK_NONE) && (!raw[i])) {
			for (j=1; j<128; j++) {
				if (!found[j]) {
					raw[i] = j;
					found[j] = i;
					keymap[j][0] = mgl_keymap[i][0];
					keymap[j][1] = mgl_keymap[i][1];
					keymap[j][2] = mgl_keymap[i][2];
					break;
				}
			}
		}
	}
	for (i=0; i< 128; i++) {
		mgl_raw_keymap[i] = raw[i];
		mgl_keymap[i][0] = keymap[i][0];
		mgl_keymap[i][1] = keymap[i][1];
		mgl_keymap[i][2] = keymap[i][2];
	}
}
